﻿
#Область Служебные_функции_и_процедуры

&НаКлиенте
// контекст фреймворка Vanessa-Automation
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Automation.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ВЖурналеРегистрацииОшибокНачинаяС(Парам01,Парам02)","ВЖурналеРегистрацииОшибокНачинаяС","И В журнале регистрации ""КоличествоОшибок"" ошибок начиная с ""Дата""","","");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции

#КонецОбласти



#Область Работа_со_сценариями

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции

#КонецОбласти


///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//И В журнале регистрации "КоличествоОшибок" ошибок начиная с "ДатаНачала"
//@ВЖурналеРегистрацииОшибокНачинаяС(пКоличествоОшибок, пДатаНачала)
Функция ВЖурналеРегистрацииОшибокНачинаяС(пКоличествоОшибок, пДатаНачала) Экспорт
	
	отЧисло = Новый ОписаниеТипов("Число", Новый КвалификаторыЧисла(10, 0, ДопустимыйЗнак.Неотрицательный));
	количествоОшибок = отЧисло.ПривестиЗначение(пКоличествоОшибок);
	
	датаНачала = ДатаИзСтроки(пДатаНачала);
	описаниеОшибок = "";
	
	ошибокВЖурнале = ЗаполнитьТабличныйДокументСЖурналом(датаНачала, описаниеОшибок);
	
	Если ошибокВЖурнале > 0 Тогда
		
		путьКЖурналу = ПолучитьИмяВременногоФайла("xlsx");
		
		ВыгрузкаЖР.Записать(путьКЖурналу, ТипФайлаТабличногоДокумента.XLSX);
		
		Ванесса.ДобавитьФайлКШагу(путьКЖурналу, "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet", "ЖурналРегистрации.xlsx");
		
		УдалитьФайлы(путьКЖурналу);
		
	КонецЕсли;
	
	Если Не ошибокВЖурнале = количествоОшибок Тогда
		
		ВызватьИсключение СтрШаблон("В ЖР ошибок %1, а ожидали %2:
		|%3", ошибокВЖурнале, количествоОшибок, описаниеОшибок);
		
	КонецЕсли;
	
КонецФункции

&НаСервере
Функция ЗаполнитьТабличныйДокументСЖурналом(Знач пДатаНачала, ОписаниеОшибок = "")
	
	ВыгрузкаЖР.Очистить();
	
	СобытияЖурнала = Новый ТаблицаЗначений;
	
	Фильтр = Новый Структура;
	
	Фильтр.Вставить("ДатаНачала", пДатаНачала);
	
	УровниРегистрацииОшибок = Новый Массив;
	УровниРегистрацииОшибок.Добавить(УровеньЖурналаРегистрации.Ошибка);
	
	Фильтр.Вставить("Уровень", УровниРегистрацииОшибок);
	
	ВыгрузитьЖурналРегистрации(СобытияЖурнала, Фильтр);
	
	Если СобытияЖурнала.Количество() = 0 Тогда
		
		ОписаниеОшибок = "";
		Возврат 0;
		
	КонецЕсли;
	
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Макет        = ОбъектСервер.ПолучитьМакет("ШаблонЖР");
	
	СекцияШапка  = Макет.ПолучитьОбласть("Шапка");
	ВыгрузкаЖР.Вывести(СекцияШапка);
	
	НомСтр = 0;
	ошибки = Новый Массив;
	
	шаблонОписания = "%1: %2";
	
	Для Каждого СтрокаСобытияЖурнала Из СобытияЖурнала Цикл
		
		Если СтрНачинаетсяС(СтрокаСобытияЖурнала.Событие, "VanessaAutomation.") Тогда
			// Ошибки по VA и так нам известны
			Продолжить;
		КонецЕсли;
		
		Если СтрНачинаетсяС(СтрокаСобытияЖурнала.Событие, "Работа с классификаторами")
			И СтрокаСобытияЖурнала.Комментарий = "Для получения обновлений классификаторов необходимо подключить Интернет-поддержку пользователей." Тогда
			// Интернет-поддержку не можем подкючить
			Продолжить;
		КонецЕсли;
		
		ошибки.Добавить(СтрШаблон(шаблонОписания, СтрокаСобытияЖурнала.ПредставлениеСобытия, СтрокаСобытияЖурнала.Комментарий));
		
		НомСтр       = НомСтр + 1;
		СекцияСтрока = Макет.ПолучитьОбласть("Строка");
		ЗаполнитьЗначенияСвойств(СекцияСтрока.Параметры, СтрокаСобытияЖурнала);
		
		СекцияСтрока.Параметры.ApplicationName         = СтрокаСобытияЖурнала.ИмяПриложения;
		СекцияСтрока.Параметры.ApplicationPresentation = СтрокаСобытияЖурнала.ПредставлениеПриложения;
		СекцияСтрока.Параметры.AuxiliaryIPPort         = СтрокаСобытияЖурнала.ВспомогательныйIPПорт;
		СекцияСтрока.Параметры.Comment                 = СтрокаСобытияЖурнала.Комментарий;
		СекцияСтрока.Параметры.Computer                = СтрокаСобытияЖурнала.Компьютер;
		СекцияСтрока.Параметры.Connection              = СтрокаСобытияЖурнала.Соединение;
		СекцияСтрока.Параметры.Data                    = СтрокаСобытияЖурнала.Данные;
		СекцияСтрока.Параметры.DataPresentation        = СтрокаСобытияЖурнала.ПредставлениеДанных;
		СекцияСтрока.Параметры.Date                    = СтрокаСобытияЖурнала.Дата;
		СекцияСтрока.Параметры.Event                   = СтрокаСобытияЖурнала.Событие;
		СекцияСтрока.Параметры.EventPresentation       = СтрокаСобытияЖурнала.ПредставлениеСобытия;
		СекцияСтрока.Параметры.Level                   = СтрокаСобытияЖурнала.Уровень;
		СекцияСтрока.Параметры.MainIPPort              = СтрокаСобытияЖурнала.ОсновнойIPПорт;
		СекцияСтрока.Параметры.Metadata                = СтрокаСобытияЖурнала.Метаданные;
		СекцияСтрока.Параметры.MetadataPresentation    = СтрокаСобытияЖурнала.ПредставлениеМетаданных;
		СекцияСтрока.Параметры.Session                 = СтрокаСобытияЖурнала.Сеанс;
		СекцияСтрока.Параметры.Transaction             = СтрокаСобытияЖурнала.Транзакция;
		СекцияСтрока.Параметры.TransactionStatus       = СтрокаСобытияЖурнала.СтатусТранзакции;
		СекцияСтрока.Параметры.User                    = СтрокаСобытияЖурнала.Пользователь;
		СекцияСтрока.Параметры.Username                = СтрокаСобытияЖурнала.ИмяПользователя;
		СекцияСтрока.Параметры.WorkingServer           = СтрокаСобытияЖурнала.РабочийСервер;
		
		СекцияСтрока.Параметры.НомСтр = НомСтр;
		ВыгрузкаЖР.Вывести(СекцияСтрока);
		
	КонецЦикла;
	
	ВыгрузкаЖР.ФиксацияСверху = 1;
	
	ОписаниеОшибок = СтрСоединить(ошибки, Символы.ПС);
	
	Возврат НомСтр;
	
КонецФункции

&НаКлиенте
Функция ДатаИзСтроки(Знач пСтрока)

	Если пСтрока = "" Тогда

		Возврат Дата(1, 1, 1);

	КонецЕсли;

	Если ТипЗнч(пСтрока) = Тип("Дата") Тогда

		Возврат пСтрока;

	КонецЕсли;

	Если Не ТипЗнч(пСтрока) = Тип("Строка") Тогда

		пСтрока = Строка(пСтрока);

	КонецЕсли;

	дата = СтрокаВДату(пСтрока, ЧастиДаты.ДатаВремя);

	Если Не ЗначениеЗаполнено(дата) Тогда

		ОписаниеТипа = Новый ОписаниеТипов("Дата");
		дата = ОписаниеТипа.ПривестиЗначение(пСтрока);

	КонецЕсли;

	Возврат дата;

КонецФункции

&НаКлиенте
Функция СтрокаВДату(Знач Значение, ЧастьДаты = Неопределено) Экспорт
	
	НаборЦифр = "1234567890";
	
	Если ТипЗнч(ЧастьДаты) <> Тип("ЧастиДаты") Тогда
		ЧастьДаты = ЧастиДаты.Дата;
	КонецЕсли;
	
	ПараметрыДаты = Новый КвалификаторыДаты(ЧастьДаты);
	ОписаниеТипаДата = Новый ОписаниеТипов("Дата",,, ПараметрыДаты);
	
	Значение = ВРег(СтрСоединить(СтрРазделить(СокрЛП(Значение), Символы.НПП + Символы.ПС + Символы.Таб), " "));
	Результат = ОписаниеТипаДата.ПривестиЗначение(Значение);
	
	Для НомерМесяца = 1 По 12 Цикл
		Значение = СтрЗаменить(Значение, ВРег(Формат(Дата(1, НомерМесяца, 2), "ДФ=MMММ")), Формат(НомерМесяца, "ЧЦ=2; ЧВН="));
		Значение = СтрЗаменить(Значение, ВРег(Формат(Дата(1, НомерМесяца, 2), "ДФ=MMM")), Формат(НомерМесяца, "ЧЦ=2; ЧВН="));
	КонецЦикла;
	
	МассивНеЦифр = СтрРазделить(Значение, НаборЦифр);
	Если МассивНеЦифр.Количество() < 2 Тогда
		Возврат Результат;
	КонецЕсли;
	
	ПозицияПервойЦифры = СтрДлина(МассивНеЦифр[0]);
	ПозицияПоследнейЦифры = СтрДлина(Значение) - СтрДлина(МассивНеЦифр[МассивНеЦифр.ВГраница()]);
	Значение = Сред(Значение, ПозицияПервойЦифры, ПозицияПоследнейЦифры - ПозицияПервойЦифры);
	Если ПустаяСтрока(Значение) Тогда
		Возврат Результат;
	КонецЕсли;
	
	ЗначениеМассивом = СтрРазделить(Значение, " ");
	Элемент = ЗначениеМассивом[ЗначениеМассивом.ВГраница()];
	Если ЗначениеМассивом.Количество() > 1 Тогда
		Если СтрДлина(Элемент) = 2 Или СтрДлина(Элемент) = 4 Тогда
			
			ЭтоТолькоЦифры = СтрРазделить(Элемент, НаборЦифр, Ложь).Количество() = 0;
			Если ЭтоТолькоЦифры Тогда
				ЗначениеДата = Значение;
				ЗначениеВремя = "";
			Иначе
				ЗначениеВремя = Элемент;
				ЗначениеМассивом.Удалить(ЗначениеМассивом.ВГраница());
				ЗначениеДата = СтрСоединить(ЗначениеМассивом, " ");
			КонецЕсли;
		Иначе
			
			ЗначениеВремя = Элемент;
			ЗначениеМассивом.Удалить(ЗначениеМассивом.ВГраница());
			ЗначениеДата = СтрСоединить(ЗначениеМассивом, " ");
		КонецЕсли;
	Иначе
		
		ЭтоТолькоЦифры = СтрРазделить(Элемент, НаборЦифр, Ложь).Количество() = 0;
		Если ЭтоТолькоЦифры Тогда
			
			Результат = ОписаниеТипаДата.ПривестиЗначение(Элемент);
			Если Не ЗначениеЗаполнено(Результат) Тогда
				
				Если СтрДлина(Элемент) = 6 Тогда
				
					ПеревернутаяДата  = Сред(Элемент, 5) + Сред(Элемент, 3, 2) + Лев(Элемент, 2);
					Год = СтрокаВЧисло(Лев(ПеревернутаяДата, 2));
					Если Год <> Неопределено Тогда
						ПеревернутаяДата = ?(Год > 29, "19", "20") + ПеревернутаяДата;
						Результат = ОписаниеТипаДата.ПривестиЗначение(ПеревернутаяДата);
					КонецЕсли;
					
				ИначеЕсли СтрДлина(Элемент) > 7 Тогда
					
					ПеревернутаяДата  = Сред(Элемент, 5) + Сред(Элемент, 3, 2) + Лев(Элемент, 2);
					Результат = ОписаниеТипаДата.ПривестиЗначение(ПеревернутаяДата);
					
				КонецЕсли;
				
			КонецЕсли;
			
			Возврат Результат;
			
		ИначеЕсли СтрНайти(Элемент, ":") > 0 Тогда
			
			ЗначениеДата = "";
			ЗначениеВремя = Элемент;
		Иначе
			ЗначениеДата = Элемент;
			ЗначениеВремя = "";
		КонецЕсли;
	КонецЕсли;
	
	ОписаниеТипаЧисло = Новый ОписаниеТипов("Число");
	
	Если ЗначениеЗаполнено(ЗначениеДата) И ЧастьДаты <> ЧастиДаты.Время Тогда
		
		НаборРазделителей = СтрСоединить(СтрРазделить(ЗначениеДата, НаборЦифр, Ложь), "");
		ЗначениеДатаМассивом = СтрРазделить(ЗначениеДата, НаборРазделителей, Ложь);
		
		ЭтоТолькоЦифры = СтрРазделить(ЗначениеДата, НаборЦифр, Ложь).Количество() = 0;
		Если НЕ ЭтоТолькоЦифры Тогда
			
			Год   = 1;
			Месяц = 1;
			День  = 1;
			
			Если СтрДлина(ЗначениеДатаМассивом[0]) = 4 Тогда
				Год = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[0]);
				ГодВНачале = Истина;
			Иначе
				День = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[0]);
				ГодВНачале = Ложь;
			КонецЕсли;
			
			Если ЗначениеДатаМассивом.Количество() = 2 Тогда
				Месяц = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[1]);;
			ИначеЕсли ЗначениеДатаМассивом.Количество() > 2 Тогда
				Месяц = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[1]);
				Если ГодВНачале Тогда
					День = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[2]);
				Иначе
					Год = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеДатаМассивом[2]);
				КонецЕсли;
			КонецЕсли;
			
			Если СтрДлина(Год) < 3 Тогда
				ГодЧислом = ОписаниеТипаЧисло.ПривестиЗначение(Год);
				Год = ?(ГодЧислом < 30, 2000, 1900) + ГодЧислом;
			Иначе
				Год = ОписаниеТипаЧисло.ПривестиЗначение(Год);
			КонецЕсли;
			
			ЗначениеДата = Формат(Год, "ЧЦ=4; ЧН=0001; ЧВН=; ЧГ=0")
				+ Формат(Месяц, "ЧЦ=2; ЧН=01; ЧВН=; ЧГ=0")
				+ Формат(День, "ЧЦ=2; ЧН=01; ЧВН=; ЧГ=0");
		Иначе
			
			Если СтрДлина(ЗначениеДата) = 6 Тогда
				
				Год = Прав(ЗначениеДата, 2);
				ГодЧислом = ОписаниеТипаЧисло.ПривестиЗначение(Год);
				ЗначениеДата = ?(ГодЧислом < 30, 2000, 1900) + Год + Сред(ЗначениеДата, 3, 2) + Лев(ЗначениеДата, 2) ;
				
			ИначеЕсли СтрДлина(ЗначениеДата) = 8 Тогда
				
				Результат = ОписаниеТипаДата.ПривестиЗначение(ЗначениеДата);
				
				Если Не ЗначениеЗаполнено(Результат) Тогда
					ПеревернутаяДата  = Сред(ЗначениеДата, 5) + Сред(ЗначениеДата, 3, 2) + Лев(ЗначениеДата, 2);
					Результат = ОписаниеТипаДата.ПривестиЗначение(ПеревернутаяДата);
					Если ЗначениеЗаполнено(Результат) Тогда
						ЗначениеДата = ПеревернутаяДата;
					КонецЕсли;
				КонецЕсли;
			
			КонецЕсли;
		КонецЕсли;
		
	Иначе
		ЗначениеДата = "00010101";
	КонецЕсли;
	
	Если ЗначениеЗаполнено(ЗначениеВремя) И ЧастьДаты <> ЧастиДаты.Дата Тогда
		
		ЭтоТолькоЦифры = СтрРазделить(ЗначениеВремя, НаборЦифр, Ложь).Количество() = 0;
		Если НЕ ЭтоТолькоЦифры Тогда
			
			НаборРазделителей = СтрСоединить(СтрРазделить(ЗначениеВремя, НаборЦифр, Ложь), "");
			ЗначениеВремяМассивом = СтрРазделить(ЗначениеВремя, НаборРазделителей, Ложь);
			
			Час     = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеВремяМассивом[0]);
			Минута  = 0;
			Секунда = 0;
			
			Если ЗначениеВремяМассивом.Количество() = 2 Тогда
				Минута = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеВремяМассивом[1]);
			ИначеЕсли ЗначениеВремяМассивом.Количество() > 2 Тогда
				Минута = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеВремяМассивом[1]);
				Секунда = ОписаниеТипаЧисло.ПривестиЗначение(ЗначениеВремяМассивом[2]);
			КонецЕсли;
			
			ШаблонФормата = "ЧЦ=2; ЧН=00; ЧВН=; ЧГ=0";
			ЗначениеВремя = Формат(Час, ШаблонФормата)
				+ Формат(Минута, ШаблонФормата)
				+ Формат(Секунда, ШаблонФормата);
				
		КонецЕсли;
		
	Иначе
		ЗначениеВремя = "000000";
	КонецЕсли;
	
	Результат = ОписаниеТипаДата.ПривестиЗначение(ЗначениеДата + ЗначениеВремя);
	
	Возврат Результат;
	
КонецФункции

&НаКлиенте
Функция СтрокаВЧисло(Знач Значение)
	
	Значение  = СтрЗаменить(Значение, " ", "");
	Если СтрНачинаетсяС(Значение, "(") Тогда
		Значение = СтрЗаменить(Значение, "(", "-");
		Значение = СтрЗаменить(Значение, ")", "");
	КонецЕсли;
	
	СтрокаБезНулей = СтрЗаменить(Значение, "0", "");
	Если ПустаяСтрока(СтрокаБезНулей) Или СтрокаБезНулей = "-" Тогда
		Возврат 0;
	КонецЕсли;
	
	ТипЧисло  = Новый ОписаниеТипов("Число");
	Результат = ТипЧисло.ПривестиЗначение(Значение);
	
	Возврат ?(Результат <> 0 И Не ПустаяСтрока(СтрокаБезНулей), Результат, Неопределено);
	
КонецФункции


